Source-Changes-HG archive
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]
[src/trunk]: src Add new c++ ATF tests in usr.bin/c++: t_hello
details: https://anonhg.NetBSD.org/src/rev/b41a5c2b82af
branches: trunk
changeset: 353592:b41a5c2b82af
user: kamil <kamil%NetBSD.org@localhost>
date: Sun May 14 00:07:07 2017 +0000
description:
Add new c++ ATF tests in usr.bin/c++: t_hello
This is a copy of t_hello from usr.bin/cc.
Added tests:
- hello
- hello_pic
- hello_pie
- hello32
These tests do not use c++ runtime library functions.
Protect these tests with MKCXX.
diffstat:
distrib/sets/lists/tests/mi | 6 +-
etc/mtree/NetBSD.dist.tests | 3 +-
tests/usr.bin/Makefile | 6 +-
tests/usr.bin/c++/Makefile | 9 ++
tests/usr.bin/c++/t_hello.sh | 145 +++++++++++++++++++++++++++++++++++++++++++
5 files changed, 166 insertions(+), 3 deletions(-)
diffs (217 lines):
diff -r 740a502782e8 -r b41a5c2b82af distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi Sat May 13 23:51:39 2017 +0000
+++ b/distrib/sets/lists/tests/mi Sun May 14 00:07:07 2017 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.738 2017/05/10 09:08:25 ozaki-r Exp $
+# $NetBSD: mi,v 1.739 2017/05/14 00:07:07 kamil Exp $
#
# Note: don't delete entries from here - mark them as "obsolete" instead.
#
@@ -3584,6 +3584,10 @@
./usr/tests/usr.bin/bzip2/d_sample3.bz2 tests-usr.bin-tests compattestfile,atf
./usr/tests/usr.bin/bzip2/d_sample3.ref tests-usr.bin-tests compattestfile,atf
./usr/tests/usr.bin/bzip2/t_bzip2 tests-usr.bin-tests compattestfile,atf
+./usr/tests/usr.bin/c++ tests-usr.bin-tests compattestfile,atf,cxx
+./usr/tests/usr.bin/c++/Atffile tests-usr.bin-tests compattestfile,atf,cxx
+./usr/tests/usr.bin/c++/Kyuafile tests-usr.bin-tests compattestfile,atf,kyua,cxx
+./usr/tests/usr.bin/c++/t_hello tests-usr.bin-tests compattestfile,atf,cxx
./usr/tests/usr.bin/cc tests-usr.bin-tests compattestfile,atf
./usr/tests/usr.bin/cc/Atffile tests-usr.bin-tests compattestfile,atf
./usr/tests/usr.bin/cc/Kyuafile tests-usr.bin-tests compattestfile,atf,kyua
diff -r 740a502782e8 -r b41a5c2b82af etc/mtree/NetBSD.dist.tests
--- a/etc/mtree/NetBSD.dist.tests Sat May 13 23:51:39 2017 +0000
+++ b/etc/mtree/NetBSD.dist.tests Sun May 14 00:07:07 2017 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: NetBSD.dist.tests,v 1.145 2017/04/14 02:56:48 ozaki-r Exp $
+# $NetBSD: NetBSD.dist.tests,v 1.146 2017/05/14 00:07:07 kamil Exp $
./usr/libdata/debug/usr/tests
./usr/libdata/debug/usr/tests/atf
@@ -376,6 +376,7 @@
./usr/tests/usr.bin/awk
./usr/tests/usr.bin/basename
./usr/tests/usr.bin/bzip2
+./usr/tests/usr.bin/c++
./usr/tests/usr.bin/cc
./usr/tests/usr.bin/cmp
./usr/tests/usr.bin/config
diff -r 740a502782e8 -r b41a5c2b82af tests/usr.bin/Makefile
--- a/tests/usr.bin/Makefile Sat May 13 23:51:39 2017 +0000
+++ b/tests/usr.bin/Makefile Sun May 14 00:07:07 2017 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: Makefile,v 1.24 2017/02/21 10:40:30 kre Exp $
+# $NetBSD: Makefile,v 1.25 2017/05/14 00:07:07 kamil Exp $
#
.include <bsd.own.mk>
@@ -11,4 +11,8 @@
pkill pr rump_server shmif_dumpbus sdiff \
sed sort tmux tr unifdef uniq vmstat xlint
+.if ${MKCXX} != "no"
+TESTS_SUBDIRS+= c++
+.endif
+
.include <bsd.test.mk>
diff -r 740a502782e8 -r b41a5c2b82af tests/usr.bin/c++/Makefile
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/usr.bin/c++/Makefile Sun May 14 00:07:07 2017 +0000
@@ -0,0 +1,9 @@
+# $NetBSD: Makefile,v 1.1 2017/05/14 00:07:07 kamil Exp $
+
+.include <bsd.own.mk>
+
+TESTSDIR= ${TESTSBASE}/usr.bin/c++
+
+TESTS_SH= t_hello
+
+.include <bsd.test.mk>
diff -r 740a502782e8 -r b41a5c2b82af tests/usr.bin/c++/t_hello.sh
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/usr.bin/c++/t_hello.sh Sun May 14 00:07:07 2017 +0000
@@ -0,0 +1,145 @@
+# $NetBSD: t_hello.sh,v 1.1 2017/05/14 00:07:07 kamil Exp $
+#
+# Copyright (c) 2011 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+#
+
+atf_test_case hello
+hello_head() {
+ atf_set "descr" "compile and run \"hello world\""
+ atf_set "require.progs" "c++"
+}
+
+atf_test_case hello_pic
+hello_pic_head() {
+ atf_set "descr" "compile and run PIC \"hello world\""
+ atf_set "require.progs" "c++"
+}
+
+atf_test_case hello_pie
+hello_pie_head() {
+ atf_set "descr" "compile and run position independent (PIE) \"hello world\""
+ atf_set "require.progs" "c++"
+}
+
+atf_test_case hello32
+hello32_head() {
+ atf_set "descr" "compile and run \"hello world\" for/in netbsd32 emulation"
+ atf_set "require.progs" "c++ file diff cat"
+}
+
+hello_body() {
+ cat > test.cpp << EOF
+#include <stdio.h>
+#include <stdlib.h>
+int main(void) {printf("hello world\n");exit(0);}
+EOF
+ atf_check -s exit:0 -o ignore -e ignore c++ -o hello test.cpp
+ atf_check -s exit:0 -o inline:"hello world\n" ./hello
+}
+
+hello_pic_body() {
+ cat > test.cpp << EOF
+#include <stdlib.h>
+int callpic(void);
+int main(void) {callpic();exit(0);}
+EOF
+ cat > pic.cpp << EOF
+#include <stdio.h>
+int callpic(void) {printf("hello world\n");return 0;}
+EOF
+
+ atf_check -s exit:0 -o ignore -e ignore \
+ c++ -fPIC -shared -o libtest.so pic.cpp
+ atf_check -s exit:0 -o ignore -e ignore \
+ c++ -o hello test.cpp -L. -ltest
+
+ export LD_LIBRARY_PATH=.
+ atf_check -s exit:0 -o inline:"hello world\n" ./hello
+}
+
+hello_pie_body() {
+ # check whether this arch supports -pie
+ if ! c++ -pie -dM -E - < /dev/null 2>/dev/null >/dev/null; then
+ atf_skip "c++ -pie not supported on this architecture"
+ fi
+ cat > test.cpp << EOF
+#include <stdio.h>
+#include <stdlib.h>
+int main(void) {printf("hello world\n");exit(0);}
+EOF
+ atf_check -s exit:0 -o ignore -e ignore c++ -fpie -pie -o hello test.cpp
+ atf_check -s exit:0 -o inline:"hello world\n" ./hello
+}
+
+hello32_body() {
+ # check whether this arch is 64bit
+ if ! c++ -dM -E - < /dev/null | fgrep -q _LP64; then
+ atf_skip "this is not a 64 bit architecture"
+ fi
+ if ! c++ -m32 -dM -E - < /dev/null 2>/dev/null > ./def32; then
+ atf_skip "c++ -m32 not supported on this architecture"
+ else
+ if fgrep -q _LP64 ./def32; then
+ atf_fail "c++ -m32 does not generate netbsd32 binaries"
+ fi
+ fi
+
+ cat > test.cpp << EOF
+#include <stdio.h>
+#include <stdlib.h>
+int main(void) {printf("hello world\n");exit(0);}
+EOF
+ atf_check -s exit:0 -o ignore -e ignore c++ -o hello32 -m32 test.cpp
+ atf_check -s exit:0 -o ignore -e ignore c++ -o hello64 test.cpp
+ file -b ./hello32 > ./ftype32
+ file -b ./hello64 > ./ftype64
+ if diff ./ftype32 ./ftype64 >/dev/null; then
+ atf_fail "generated binaries do not differ"
+ fi
+ echo "32bit binaries on this platform are:"
+ cat ./ftype32
+ echo "While native (64bit) binaries are:"
+ cat ./ftype64
+ atf_check -s exit:0 -o inline:"hello world\n" ./hello32
+
+ # do another test with static 32bit binaries
+ cat > test.cpp << EOF
+#include <stdio.h>
+#include <stdlib.h>
+int main(void) {printf("hello static world\n");exit(0);}
+EOF
+ atf_check -s exit:0 -o ignore -e ignore c++ -o hello -m32 \
+ -static test.cpp
+ atf_check -s exit:0 -o inline:"hello static world\n" ./hello
+}
+
+atf_init_test_cases()
+{
+
+ atf_add_test_case hello
+ atf_add_test_case hello_pic
+ atf_add_test_case hello_pie
+ atf_add_test_case hello32
+}
Home |
Main Index |
Thread Index |
Old Index